#!/bin/sh
# Demisto API V1

source /etc/asl/config

if [ "$HIDS_DEMISTO_BAN" != "yes" ]; then
	exit;
fi


ACTION=$1
USER=$2
IP=$3
ALERTID=$4
RULEID=$5
PWD=`pwd`
DATE=`date`
LOG_FILE="/var/ossec/logs/active-responses.log"
ERROR_LOG="/var/asl/data/demisto-error.log"
CURL=/usr/bin/curl
URL=""
API_FILE="/etc/asl/demisto_clientapi"


if [ "$HIDS_DEMISTO_BAN" != "yes" ]; then
  exit;
fi




echo "`date` $0 $1 $2 $3 $4 $5" >>  ${LOG_FILE}

# Checking for an IP
if [ "x${IP}" = "x" ]; then
   echo "$0: <action> <username> <ip>"
   exit 1;
fi

# Blocking IP
if [ "x${ACTION}" != "xadd" -a "x${ACTION}" != "xdelete" ]; then
   echo "$0: invalid action: ${ACTION}"
   exit 1;
fi

while read line; do
  arrLine=(${line//,/ })
  if [ "x${ACTION}" = "xadd" ]; then
  $CURL "https://${arrLine[0]}/incident/json" -H 'content-type: application/json' -H 'accept: application/json' -H "Authorization: ${arrLine[1]}" --data-binary "{\"date\":\"'$DATE'\",\"event\":{\"action\":\"'$ACTION'\",\"ip\":\"'$IP'\",\"alertid\":\"'$ALERTID'\",\"ruleid\":\"'$RULEID'\",\"description\":\"Atomicorp Active Response\"}}" --compressed
  if [ "$?" -ne "0" ]; then
    echo "ERROR" > $ERROR_LOG
    $CURL -v "https://${arrLine[0]}/incident/json" -H 'content-type: application/json' -H 'accept: application/json' -H "Authorization: ${arrLine[1]}" --data-binary "{\"date\":\"'$DATE'\",\"event\":{\"action\":\"'$ACTION'\",\"ip\":\"'$IP'\",\"alertid\":\"'$ALERTID'\",\"ruleid\":\"'$RULEID'\",\"description\":\"Atomicorp Active Response\"}}" --compressed > $ERROR_LOG
  fi

  fi

  echo $line
done < $API_FILE
